#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Info {
    int mn = 0, cnt = 0;
    Info() = default;
    Info(int a, int b) : mn(a), cnt(b) {}
};

Info operator+(Info a, Info b) {
    return {min(a.mn, b.mn), (a.mn <= b.mn) * a.cnt + (b.mn <= a.mn) * b.cnt};
}

vector<Info> t;
vector<int> tag;

int sz = 1;

void apply(Info &a, int tg) {
    a.mn += tg;
}

void apply(int x, int tg) {
    apply(t[x], tg);
    tag[x] += tg;
}

void push(int x) {
    apply(x << 1, tag[x]);
    apply(x << 1 | 1, tag[x]);
    tag[x] = 0;
}

void pull(int x) {
    t[x] = t[x << 1] + t[x << 1 | 1];
}

void init(int n, vector<int> a) {
    sz = 1 << __lg(n) + bool(n & (n - 1));
    t.resize(sz << 1), tag.resize(sz << 1);
    for (int i = 0; i < n; ++i) {
        t[i + sz] = Info(0, a[i]);
    }
    for (int i = sz - 1; i > 0; --i) {
        pull(i);
    }
}

void rangeAdd(int l, int r, int val, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) return;
    if (l <= lx && rx <= r) {
        apply(x, val);
        return;
    }
    push(x);
    int mid = (lx + rx) >> 1;
    rangeAdd(l, r, val, x << 1, lx, mid), rangeAdd(l, r, val, x << 1 | 1, mid, rx);
    pull(x);
}

ll rectangle_union(vector<array<int, 4>> rect) { //x1, y1, x2, y2
    vector<int> yy;
    int n = rect.size();
    for (int i = 0; i < n; ++i) {
        yy.push_back(rect[i][1]), yy.push_back(rect[i][3]);
    }

    sort(yy.begin(), yy.end());
    yy.resize(unique(yy.begin(), yy.end()) - yy.begin());

    int siz = yy.size();
    vector<int> a(siz - 1);
    for (int i = 0; i < siz - 1; ++i) {
        a[i] = yy[i + 1] - yy[i];
    }

    init(siz - 1, a);

    auto shrink = [&](int x) {
        return lower_bound(yy.begin(), yy.end(), x) - yy.begin();
    };

    vector<array<int, 4>> events;

    for (auto &[x1, y1, x2, y2] : rect) {
        y1 = shrink(y1), y2 = shrink(y2);
        events.push_back({x1, 1, y1, y2});
        events.push_back({x2, -1, y1, y2});
    }

    ll ans = 0;
    sort(events.begin(), events.end());

    int last = -1e9;
    for (auto [x, tg, l, r] : events) {
        if (x != last) {
            ans += 1LL * (x - last) * (yy.back() - yy.front() - (t[1].mn == 0) * t[1].cnt);
        }

        rangeAdd(l, r, tg);
        last = x;
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int k, n;
    cin >> k >> n;

    array<int, 4> cord{0, 0, k, k};

    vector<array<int, 4>> rect{cord};
    for (int _ = 0; _ < n; ++_) {
        char c;
        cin >> c;
        int a;
        cin >> a;

        int dx = (c == 'W' ? -1 : c == 'E' ? 1 : 0);
        int dy = (c == 'N' ? 1 : c == 'S' ? -1 : 0);

        dx *= a, dy *= a;

        auto nxt = cord;
        nxt[0] += dx, nxt[2] += dx;
        nxt[1] += dy, nxt[3] += dy;

        int x1 = min(nxt[0], cord[0]);
        int y1 = min(nxt[1], cord[1]);
        int x2 = max(nxt[2], cord[2]);
        int y2 = max(nxt[3], cord[3]);

        rect.push_back({x1, y1, x2, y2});

        cord = nxt;
    }

    cout << rectangle_union(rect) << '\n';

    return 0;
}
