#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using u64 = unsigned long long;

struct pt {
    ll x, y;

    pt() = default;

    pt(ll x, ll y) : x(x), y(y) {}

    pt(int x, int y) : x(x), y(y) {}

    ll crs(pt oth) {
        return x * oth.y - y * oth.x;
    }

    ll dot(pt oth) {
        return x * oth.x + y * oth.y;
    }

    ll dist2() {
        return x * x + y * y;
    }

    pt operator-(pt oth) {
        return {x - oth.x, y - oth.y};
    }

    pt operator+(pt oth) {
        return {x + oth.x, y + oth.y};
    }
};

int sign(ll x) {
    return x > 0 ? 1 : x == 0 ? 0 : -1;
}

constexpr int MAXN = 1000;

vector<int> adj[MAXN * MAXN];
int fi[MAXN * MAXN], se[MAXN * MAXN];
int ans[MAXN], used[MAXN * MAXN];

u64 dp[MAXN * MAXN];

bitset<MAXN> bs[MAXN * MAXN];

bool is_left(pt a, pt b) {
    return sign(a.crs(b)) == 1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, t;
    cin >> n >> t;

    t -= 1;

    vector<pt> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].x >> p[i].y;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            fi[i * n + j] = i, se[i * n + j] = j;
        }
    }

    auto addEdge = [&](int from, int to) {
        assert(from != 0);

        adj[from].push_back(to);

        assert(adj[from].size() == 1);

//        cout << from / n + 1 << " " << from % n + 1 << " -> " << to / n + 1 << " " << to % n + 1 << endl;
    };

    vector<pt> p_(n);

    for (int s = 0; s < n; ++s) {
        for (int j = 0; j < n; ++j) {
            p_[j] = p[j] - p[s];
        }


        int oth = -1;
        ll best = -1;
        for (int i = 0; i < n; ++i) {
            if (i != s) {
                ll dist = (p[s] - p[i]).dist2();
                if (oth == -1 || dist < best) {
                    oth = i;
                    best = dist;
                }
            }
        }


        vector<int> left, same, opp, right;


        auto vec = p_[oth];

        p_.resize(2 * n);
        for (int i = 0; i < n; ++i) {
            if (i != s) {
                p_[i + n] = p[s] - p[i];
            }
        }

        for (int j = 0; j < 2 * n; ++j) {
            if (j != s && j != oth && j != n + s) {
                ll crs = vec.crs(p_[j]);
                if (sign(crs) == 0) {
                    ll dot = vec.dot(p_[j]);
                    if (sign(dot) == 1) {
                        same.push_back(j);
                    } else {
                        assert(sign(dot) == -1);
                        opp.push_back(j);
                    }
                } else {
                    if (is_left(vec, p_[j])) {
                        left.push_back(j);
                    } else {
                        right.push_back(j);
                    }
                }
            }
        }

        auto srt = [&](vector<int> &a) {
            sort(a.begin(), a.end(), [&](int x, int y) {
                ll crs = p_[x].crs(p_[y]);
                if (sign(crs) == 0) {
                    return (x < n) * p_[x].dist2() < (y < n) * p_[y].dist2();
                } else {
                    return is_left(p_[x], p_[y]);
                }
            });
        };

        same.insert(same.begin(), oth);

        srt(left), srt(right), srt(same), srt(opp);

        vector<int> ord;
//        ord.push_back(oth);

        for (auto &v: {opp, right, same, left}) {
            for (int x: v) {
                ord.push_back(x);
            }
        }

//        cout << s + 1 << ": ";

        vector<int> only;
        for (int x : ord) {
            if (x < n) only.push_back(x);
        }

        vector<int> invo(n, -1);
        for (int i = 0; i < only.size(); ++i) {
            invo[only[i]] = i;
        }

        int m = ord.size();
        vector<int> nxt(m, -1);
        for (int _ = 0; _ < 2; ++_) {
            for (int i = m - 1; i >= 0; --i) {
                if (ord[(i + 1) % m] < n) {
                    nxt[i] = (i + 1) % m;
                } else if (nxt[(i + 1) % m] != -1) {
                    nxt[i] = nxt[(i + 1) % m];
                }
            }
        }
        vector<int> inv1(n, -1), inv2(n, -1);
        for (int i = 0; i < m; ++i) {
            if (ord[i] < n) {
                inv1[ord[i]] = i;
            } else {
                inv2[ord[i] - n] = i;
            }
        }
        for (int i = 0; i < n; ++i) {
            if (i != s) {
                assert(inv1[i] != -1 && inv2[i] != -1);
                int to = nxt[inv2[i]];
                addEdge(i * n + s, s * n + only[(invo[ord[to]] + t) % (only.size())]);
            }

        }

//        cout << endl;
    }

    const int N = n * n;

    vector<int> stk, tops;

    function<void(int)> dfs = [&](int v) {
        used[v] = 1;
        stk.push_back(v);
        bs[v][fi[v]] = 1;

        for (int to: adj[v]) {
            if (!used[to]) {
                dfs(to);
            } else if (used[to] == 1) {
//                cout << v << endl;

                for (int x = int(stk.size()) - 1; x >= 0; --x) {
//                    cout << fi[stk[x]] << " " << se[stk[x]] << endl;
                    ans[fi[stk[x]]] |= 1;
                    ans[se[stk[x]]] |= 1;

                    if (stk[x] == to) {
                        break;
                    }
                }
//                cout << endl;
            }
            if (bs[to][fi[v]]) {
                ans[fi[v]] |= 2;
            }
            bs[v] |= bs[to];
        }

        used[v] = 2;
        stk.pop_back();
        tops.push_back(v);
    };

    for (int i = 0; i < N; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

//    for (int f = 0; f < n; f += 64) {
//        for (int i = 0; i < N; ++i) {
//            if (fi[i] >= f && fi[i] < f + 64) {
//                dp[i] = 1 << (fi[i] - f);
//            } else {
//                dp[i] = 0;
//            }
//        }
//
//        for (int v : tops) {
//            for (int to : adj[v]) {
//                dp[v] |= dp[to];
//
//                if (fi[v] >= f && fi[v] < f + 64 && (dp[to] >> (fi[v] - f) & 1)) {
//                    ans[fi[v]] |= 2;
//                }
//            }
//        }
//    }

    for (int i = 0; i < n; ++i) {
        if (ans[i] & 1) {
            cout << "G";
        } else if (ans[i] & 2) {
            cout << "B";
        } else {
            cout << "R";
        }
    }
    cout << '\n';

    return 0;
}
