#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> t;
int sz = 1;

void init(int n, vector<int> a) {
    sz = 1 << __lg(n) + !!(n & (n - 1));
    t.resize(sz << 1);
    for (int i = 0; i < n; ++i) {
        t[i + sz] = a[i];
    }
    for (int i = sz - 1; i > 0; --i) {
        t[i] = max(t[i << 1], t[i << 1 | 1]);
    }
}

int find_last_bigger(int r, int val, int x = 1, int lx = 0, int rx = sz) {
    if (lx >= r || t[x] <= val) {
        return -1;
    }
    if (lx + 1 == rx) {
        return lx;
    }
    int mid = (lx + rx) / 2;
    int ans = find_last_bigger(r, val, x << 1 | 1, mid, rx);
    if (ans != -1) {
        return ans;
    }
    return find_last_bigger(r, val, x << 1, lx, mid);
}

int find_first_bigger(int l, int val, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || t[x] <= val) {
        return -1;
    }
    if (lx + 1 == rx) {
        return lx;
    }
    int mid = (lx + rx) / 2;
    int ans = find_first_bigger(l, val, x << 1, lx, mid);
    if (ans != -1) {
        return ans;
    }
    return find_first_bigger(l, val, x << 1 | 1, mid, rx);
}

constexpr int N = 1e5 + 1;
const int logn = __lg(N) + 1;

int mx[logn][N];

int rangeMax(int l, int r) {
    int lg = __lg(r - l);
    return max(mx[lg][l], mx[lg][r - (1 << lg)]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        mx[0][i] = a[i];
    }

    int max_log = __lg(n) + 1;
    for (int i = 1; i < max_log; ++i) {
        for (int j = 0; j <= n - (1 << i) + 1; ++j) {
            mx[i][j] = max(mx[i - 1][j], mx[i - 1][j + (1 << i - 1)]);
        }
    }

    init(n, a);

    auto moves_needed = [&](int start, int aim) {
        if (start == aim) {
            return 1;
        }
        if (start < aim) {
            int mx = rangeMax(start + 1, aim + 1);
            int la = find_last_bigger(start, mx);
            return aim - la;
        } else {
            int mx = rangeMax(aim, start);
            int fi = find_first_bigger(start + 1, mx);
            if (fi == -1) {
                fi = n;
            }
            return fi - aim;
        }
    };

    while (q--) {
        int j, k;
        cin >> j >> k;
        --j;

        if (k == 1) {
            cout << "1\n";
            continue;
        }

        int ans = 0;

        int lo = j, hi = n;
        while (lo + 1 < hi) {
            int mid = (lo + hi) / 2;
            if (moves_needed(mid, j) <= k) {
                lo = mid;
            } else {
                hi = mid;
            }
        }

        ans += lo;

        hi = lo + 1;
        lo = j;
        while (lo + 1 < hi) {
            int mid = (lo + hi) / 2;
            if (moves_needed(mid, j) < k) {
                lo = mid;
            } else {
                hi = mid;
            }
        }

        ans -= lo;

        lo = -1, hi = j;
        while (lo + 1 < hi) {
            int mid = (lo + hi) / 2;
            if (moves_needed(mid, j) <= k) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        ans -= hi;

        lo = hi - 1;
        hi = j;
        while (lo + 1 < hi) {
            int mid = (lo + hi) / 2;
            if (moves_needed(mid, j) < k) {
                hi = mid;
            } else {
                lo = mid;
            }
        }

        ans += hi;

        cout << ans << '\n';
    }

    return 0;
}
