#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

int power(int a, int b = MOD - 2) {
    int res = 1;
    for (; b > 0; b /= 2, a = 1LL * a * a % MOD) if (b & 1) res = 1LL * res * a % MOD;
    return res;
}

constexpr int N = 1e6 + 7;

int fact[N], ifact[N];

int C(int n, int k) {
    return n < 0 || k > n ? 0 : 1LL * fact[n] * ifact[n - k] % MOD * ifact[k] % MOD;
}

void initF() {
    fact[0] = ifact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = 1LL * fact[i - 1] * i % MOD;
    }
    ifact[N - 1] = power(fact[N - 1]);
    for (int i = N - 2; i > 0; --i) {
        ifact[i] = 1LL * ifact[i + 1] * (i + 1) % MOD;
    }
}

int solve(string s) {
    int cnt[3]{};
    int e[3][3]{};
    int n = s.size();
    for (int i = 0; i < n - 1; ++i) {
        e[s[i] - 'a'][s[i + 1] - 'a'] += 1;
    }
    int alive = 0;
    for (int i = 0; i < n; ++i) {
        ++cnt[s[i] - 'a'];
    }
    for (int i = 0; i < 3; ++i) {
        alive += !!cnt[i];
    }
    int in[3]{}, out[3]{};
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            in[j] += e[i][j];
            out[i] += e[i][j];
        }
    }
    int bad = -1;
    for (int i = 0; i < 3; ++i) {
        if (in[i] > out[i]) {
            assert(bad == -1);
            bad = i;
        }
    }
    int ans = 1;
    for (int i = 0; i < 3; ++i) {
        ans = 1LL * ans * C(out[i], e[i][0]) % MOD * C(out[i] - e[i][0], e[i][1]) % MOD;
    }
//    if (bad == -1) {
//        ans = 1LL * alive * ans % MOD;
//    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    initF();

    int G;
    cin >> G;

    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;

        cout << solve(s) << '\n';
    }


    return 0;
}
