#include <bits/stdc++.h>

using namespace std;
using ll = long long;


constexpr int MOD = 1e9 + 7;


struct Mint {
    int x;

    Mint() = default;

    Mint(ll x) : x(x % MOD) {}

    Mint(int x) : x(x % MOD) {}

    Mint operator+(Mint b) const {
        return x + b.x >= MOD ? x + b.x - MOD : x + b.x;
    }

    Mint &operator+=(Mint b) {
        return (*this) = (*this) + b;
    }

    Mint operator*(Mint b) const {
        return 1LL * x * b.x % MOD;
    }

    Mint &operator*=(Mint b) {
        return (*this) = (*this) * b;
    }
};

Mint power(Mint a, int b = MOD - 2) {
    Mint res = 1;
    for (; b > 0; b /= 2, a *= a) if (b & 1) res *= a;
    return res;
}

constexpr int N = 2e6 + 7;

Mint fact[N], ifact[N];

Mint C(int n, int k) {
    return k == 0 ? 1 : n < 0 || k > n ? 0 : fact[n] * ifact[n - k] * ifact[k];
}

void initF() {
    fact[0] = ifact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = fact[i - 1] * i;
    }
    ifact[N - 1] = power(fact[N - 1]);
    for (int i = N - 2; i > 0; --i) {
        ifact[i] = ifact[i + 1] * (i + 1);
    }
}

bool stress = true;


Mint solve(int e[3][3], int add = -1) {
    int in[3]{}, out[3]{}, self[3]{};
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (i != j) {
                in[j] += e[i][j];
                out[i] += e[i][j];
            } else {
                self[i] += e[i][j];
            };
        }
    }
    int from = -1, to = -1;
    for (int i = 0; i < 3; ++i) {
        if (in[i] > out[i]) { ;
            to = i;
        } else if (in[i] != out[i]) {
            from = i;
        }
    }
    assert(from != -1);
    auto calc = [&]() {
        Mint val = 1;
        for (int i = 0; i < 3; ++i) {
            val = val * C(out[i], e[i][(i == 0)]);
        }
        return val;
    };

    auto removeEdge = [&](int i, int j) {
        e[i][j] -= 1;
        out[i] -= 1;
        in[j] -= 1;
    };;

    auto addEdge = [&](int i, int j) {
        e[i][j] += 1;
        out[i] += 1;
        in[j] += 1;
    };

    Mint ans = 0;
    if (e[from][to]) {
        removeEdge(from, to);
        ans += calc();
        addEdge(from, to);
    }
    int oth = 3 - from - to;
    if (e[from][oth] && e[oth][to]) {
        removeEdge(from, oth);
        removeEdge(oth, to);
        ans += calc();
        addEdge(from, oth);
        addEdge(oth, to);
    }
    for (int j = 0; j < 3; ++j) {
        if (self[j]) {
            ans = ans * C((add == j) + max(out[j], in[j]) + self[j] - 1, self[j]);
        }
    }
    return ans;
}

Mint solve(string s) {
    if (s == string(s.size(), s[0])) {
        return 1;
    }

    int n = s.size();
    if (*max_element(s.begin(), s.end()) - 'a' < 2) {
        int sa = 0, sb = 0;
        int edges = 0;
        for (int i = 0; i < n; ++i) {
            if (i > 0 && s[i] != s[i - 1]) edges += 1;
            else if (i > 0) {
                if (s[i] == 'a') sa += 1;
                else sb += 1;
            }
        }
        auto ez = [&](int ea, int eb) {
            return C(ea + sa - 1, sa) * C(eb + sb - 1, sb);
        };
        if (s[0] != s[n - 1]) {
            assert(edges & 1);
            return ez(edges / 2 + 1, edges / 2 + 1);
        } else {
            assert(edges % 2 == 0);
            return ez(edges / 2, edges / 2 + 1) + ez(edges / 2 + 1, edges / 2);
        }
    }

    int e[3][3]{};
    for (int i = 0; i < n - 1; ++i) {

        e[s[i] - 'a'][s[i + 1] - 'a'] += 1;
    }
    int in[3]{}, out[3]{}, self[3]{};
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (i != j) {
                in[j] += e[i][j];
                out[i] += e[i][j];
            } else {
                self[i] += e[i][j];
            };
        }
    }
    int from = -1, to = -1;
    for (int i = 0; i < 3; ++i) {
        if (in[i] > out[i]) {
            to = i;
        } else if (in[i] != out[i]) {
            from = i;
        }
    }

    auto removeEdge = [&](int i, int j) {
        e[i][j] -= 1;
        out[i] -= 1;
        in[j] -= 1;
    };;

    auto addEdge = [&](int i, int j) {
        e[i][j] += 1;
        out[i] += 1;
        in[j] += 1;
    };

    if (from == -1) {
        Mint ans = 0;
        for (int i = 0; i < 3; ++i) {
            if (!out[i] && !in[i] && !self[i]) continue;
            for (int p = 0; p < 3; ++p) {
                if (p != i && e[i][p]) {
                    removeEdge(i, p);
                    ans = (ans + solve(e, i));
                    addEdge(i, p);
                }
            }
        }
        return ans;
    }
    return solve(e);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    initF();

    int G;
    cin >> G;

    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;

        cout << solve(s).x << '\n';
    }


    return 0;
}
