#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

void add(int &x, int y) {
    if ((x += y) >= MOD) x -= MOD;
}

int power(int a, int b = MOD - 2) {
    int res = 1;
    for (; b > 0; b /= 2, a = 1LL * a * a % MOD) if (b & 1) res = 1LL * res * a % MOD;
    return res;
}

constexpr int N = 1e6 + 7;

int fact[N], ifact[N];

int C(int n, int k) {
    return n < 0 || k > n ? 0 : 1LL * fact[n] * ifact[n - k] % MOD * ifact[k] % MOD;
}

void initF() {
    fact[0] = ifact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = 1LL * fact[i - 1] * i % MOD;
    }
    ifact[N - 1] = power(fact[N - 1]);
    for (int i = N - 2; i > 0; --i) {
        ifact[i] = 1LL * ifact[i + 1] * (i + 1) % MOD;
    }
}

bool stress = true;

constexpr int lim = 10;

map<array<int, 9>, int> mp[lim];

void rec(int last, int n, array<int, 9> &a) {
    add(mp[n][a], 1);
    if (n + 1 >= lim) return;
    for (int i = 0; i < 3; ++i) {
        if (n) {
            a[last * 3 + i] += 1;
        }
        rec(i, n + 1, a);
        if (n) {
            a[last * 3 + i] -= 1;
        }
    }
}

int solve(int e[3][3], int add = -1) {
    int in[3]{}, out[3]{}, self[3]{};
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (i != j) {
                in[j] += e[i][j];
                out[i] += e[i][j];
            } else {
                self[i] += e[i][j];
            };
        }
    }
    int from = -1, to = -1;
    for (int i = 0; i < 3; ++i) {
        if (in[i] > out[i]) { ;
            to = i;
        } else if (in[i] != out[i]) {
            from = i;
        }
    }
    assert(from != -1);
    auto calc = [&]() {
        int val = 1;
        for (int i = 0; i < 3; ++i) {
            val = 1LL * val * C(out[i], e[i][(i == 0)]) % MOD;
        }
        return val;
    };

    auto removeEdge = [&](int i, int j) {
        e[i][j] -= 1;
        out[i] -= 1;
        in[j] -= 1;
    };;

    auto addEdge = [&](int i, int j) {
        e[i][j] += 1;
        out[i] += 1;
        in[j] += 1;
    };

    int ans = 0;
    if (e[from][to]) {
        removeEdge(from, to);
        ans += calc();
        if (ans >= MOD) ans -= MOD;
        addEdge(from, to);
    }
    int oth = 3 - from - to;
    if (e[from][oth] && e[oth][to]) {
        removeEdge(from, oth);
        removeEdge(oth, to);
        ans += calc();
        if (ans >= MOD) ans -= MOD;
        addEdge(from, oth);
        addEdge(oth, to);
    }
    for (int j = 0; j < 3; ++j) {
        if (self[j]) {
            ans = 1LL * ans * C((add == j) + max(out[j], in[j]) + self[j] - 1, self[j]) % MOD;
        }
    }
    return ans;
}

int solve(string s) {
    if (s == string(s.size(), s[0])) {
        return 1;
    }

    int cnt[3]{};
    int e[3][3]{};
    int n = s.size();
    for (int i = 0; i < n - 1; ++i) {
        e[s[i] - 'a'][s[i + 1] - 'a'] += 1;
    }
    int alive = 0;
    for (int i = 0; i < n; ++i) {
        ++cnt[s[i] - 'a'];
    }
    for (int i = 0; i < 3; ++i) {
        alive += !!cnt[i];
    }
    int in[3]{}, out[3]{}, self[3]{};
    for (int i = 0; i < 3; ++i) {
        for (int j = 0; j < 3; ++j) {
            if (i != j) {
                in[j] += e[i][j];
                out[i] += e[i][j];
            } else {
                self[i] += e[i][j];
            };
        }
    }
    int from = -1, to = -1;
    for (int i = 0; i < 3; ++i) {
        if (in[i] > out[i]) { ;
            to = i;
        } else if (in[i] != out[i]) {
            from = i;
        }
    }

    auto calc = [&]() {
        int val = 1;
        for (int i = 0; i < 3; ++i) {
            val = 1LL * val * C(out[i], e[i][(i == 0)]) % MOD;
        }
        return val;
    };

    auto removeEdge = [&](int i, int j) {
        e[i][j] -= 1;
        out[i] -= 1;
        in[j] -= 1;
    };;

    auto addEdge = [&](int i, int j) {
        e[i][j] += 1;
        out[i] += 1;
        in[j] += 1;
    };

    if (from == -1) {
        int ans = 0;
        for (int i = 0; i < 3; ++i) {
            if (!out[i] && !in[i] && !self[i]) continue;
            for (int p = 0; p < 3; ++p) {
                if (p != i && e[i][p]) {
                    removeEdge(i, p);
                    ans = (ans + solve(e, i)) % MOD;
                    addEdge(i, p);
                }
            }
        }
        return ans;
    }
    return solve(e);
}

void stres(string a) {
    int wrong = solve(a);
    array<int, 9> aa{};
    for (int i = 0; i + 1 < a.size(); ++i) {
        aa[(a[i] - 'a') * 3 + a[i + 1] - 'a'] += 1;
    }
    int correct = mp[a.size()][aa];
    if (wrong != correct) {
        cout << a << endl;
        cout << "correct: " << correct << endl;
        cout << "wrong: " << wrong << endl;
        exit(0);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    initF();

    stress = false;
    if (stress) {
        auto kek = array<int, 9>{};
        rec(-1, 0, kek);
    }
    if (stress) {
        mt19937 rnd(228);
        int n = lim - 1, cnt = 0;
        while (true) {
            string s(n, '?');
            for (int i = 0; i < n; ++i) {
                s[i] = 'a' + (rnd() % 3);
            }
            stres(s);
            if (++cnt % 100 == 0) {
                cout << "OK: " << cnt << endl;
            }
        }
        return 0;
    }

    int G;
    cin >> G;

    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;

        cout << solve(s) << '\n';
    }


    return 0;
}
